## cryfs 0.10.2

=== CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(gitversion)
add_subdirectory(cpp-utils)
add_subdirectory(fspp)
add_subdirectory(parallelaccessstore)
add_subdirectory(blockstore)
add_subdirectory(blobstore)
add_subdirectory(cryfs)
add_subdirectory(cryfs-cli)
add_subdirectory(cryfs-unmount)
add_subdirectory(stats)

=== blobstore/CMakeLists.txt ===
project (blobstore-test)

set(SOURCES
    implementations/onblocks/utils/MaxZeroSubtractionTest.cpp
    implementations/onblocks/utils/CeilDivisionTest.cpp
    implementations/onblocks/utils/IntPowTest.cpp
    implementations/onblocks/utils/CeilLogTest.cpp
    implementations/onblocks/testutils/BlobStoreTest.cpp
    implementations/onblocks/BlobStoreTest.cpp
    implementations/onblocks/datanodestore/DataLeafNodeTest.cpp
    implementations/onblocks/datanodestore/DataInnerNodeTest.cpp
    implementations/onblocks/datanodestore/DataNodeViewTest.cpp
    implementations/onblocks/datanodestore/DataNodeStoreTest.cpp
    implementations/onblocks/datatreestore/testutils/DataTreeTest.cpp
    implementations/onblocks/datatreestore/impl/GetLowestRightBorderNodeWithMoreThanOneChildOrNullTest.cpp
    implementations/onblocks/datatreestore/impl/GetLowestInnerRightBorderNodeWithLessThanKChildrenOrNullTest.cpp
    implementations/onblocks/datatreestore/DataTreeTest_Performance.cpp
    implementations/onblocks/datatreestore/DataTreeTest_ResizeByTraversing.cpp
    implementations/onblocks/datatreestore/DataTreeTest_NumStoredBytes.cpp
    implementations/onblocks/datatreestore/DataTreeTest_ResizeNumBytes.cpp
    implementations/onblocks/datatreestore/DataTreeStoreTest.cpp
    implementations/onblocks/datatreestore/LeafTraverserTest.cpp
    implementations/onblocks/BlobSizeTest.cpp
    implementations/onblocks/BlobReadWriteTest.cpp
    implementations/onblocks/BigBlobsTest.cpp

)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} my-gtest-main googletest blobstore)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== blockstore/CMakeLists.txt ===
project (blockstore-test)

set(SOURCES
    utils/BlockStoreUtilsTest.cpp
    interface/BlockStoreTest.cpp
    interface/BlockStore2Test.cpp
    interface/BlockTest.cpp
    implementations/testfake/TestFakeBlockStoreTest.cpp
    implementations/mock/MockBlockStoreTest.cpp
    implementations/inmemory/InMemoryBlockStoreTest.cpp
    implementations/parallelaccess/ParallelAccessBlockStoreTest_Generic.cpp
    implementations/parallelaccess/ParallelAccessBlockStoreTest_Specific.cpp
    implementations/compressing/CompressingBlockStoreTest.cpp
    implementations/compressing/compressors/testutils/CompressorTest.cpp
    implementations/encrypted/EncryptedBlockStoreTest_Generic.cpp
    implementations/encrypted/EncryptedBlockStoreTest_Specific.cpp
    implementations/ondisk/OnDiskBlockStoreTest_Generic.cpp
    implementations/ondisk/OnDiskBlockStoreTest_Specific.cpp
    implementations/ondisk/OnDiskBlockTest/OnDiskBlockCreateTest.cpp
    implementations/ondisk/OnDiskBlockTest/OnDiskBlockFlushTest.cpp
    implementations/ondisk/OnDiskBlockTest/OnDiskBlockLoadTest.cpp
    implementations/caching/CachingBlockStore2Test_Generic.cpp
    implementations/caching/CachingBlockStore2Test_Specific.cpp
    implementations/caching/cache/QueueMapTest_Values.cpp
    implementations/caching/cache/testutils/MinimalKeyType.cpp
    implementations/caching/cache/testutils/CopyableMovableValueType.cpp
    implementations/caching/cache/testutils/MinimalValueType.cpp
    implementations/caching/cache/testutils/QueueMapTest.cpp
    implementations/caching/cache/testutils/CacheTest.cpp
    implementations/caching/cache/QueueMapTest_Size.cpp
    implementations/caching/cache/CacheTest_MoveConstructor.cpp
    implementations/caching/cache/CacheTest_PushAndPop.cpp
    implementations/caching/cache/QueueMapTest_MoveConstructor.cpp
    implementations/caching/cache/QueueMapTest_MemoryLeak.cpp
    implementations/caching/cache/CacheTest_RaceCondition.cpp
    implementations/caching/cache/PeriodicTaskTest.cpp
    implementations/caching/cache/QueueMapTest_Peek.cpp
    implementations/integrity/KnownBlockVersionsTest.cpp
    implementations/integrity/IntegrityBlockStoreTest_Generic.cpp
    implementations/integrity/IntegrityBlockStoreTest_Specific.cpp
    implementations/low2highlevel/LowToHighLevelBlockStoreTest.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} my-gtest-main googletest blockstore)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== cryfs/CMakeLists.txt ===
project (cryfs)

set(LIB_SOURCES
#    cryfs.cpp
        CryfsException.cpp
        config/crypto/outer/OuterConfig.cpp
        config/crypto/outer/OuterEncryptor.cpp
        config/crypto/CryConfigEncryptorFactory.cpp
        config/crypto/inner/ConcreteInnerEncryptor.cpp
        config/crypto/inner/InnerConfig.cpp
        config/crypto/inner/InnerEncryptor.cpp
        config/crypto/CryConfigEncryptor.cpp
        config/CryConfigConsole.cpp
        config/CryConfigLoader.cpp
        config/CryConfig.cpp
        config/CryConfigFile.cpp
        config/CryCipher.cpp
        config/CryConfigCreator.cpp
        config/CryKeyProvider.cpp
        config/CryPasswordBasedKeyProvider.cpp
        config/CryPresetPasswordBasedKeyProvider.cpp
        filesystem/CryOpenFile.cpp
        filesystem/fsblobstore/utils/DirEntry.cpp
        filesystem/fsblobstore/utils/DirEntryList.cpp
        filesystem/fsblobstore/FsBlobStore.cpp
        filesystem/fsblobstore/FsBlobView.cpp
        filesystem/fsblobstore/FileBlob.cpp
        filesystem/fsblobstore/FsBlob.cpp
        filesystem/fsblobstore/SymlinkBlob.cpp
        filesystem/fsblobstore/DirBlob.cpp
        filesystem/CryNode.cpp
        filesystem/parallelaccessfsblobstore/DirBlobRef.cpp
        filesystem/parallelaccessfsblobstore/ParallelAccessFsBlobStore.cpp
        filesystem/parallelaccessfsblobstore/ParallelAccessFsBlobStoreAdapter.cpp
        filesystem/parallelaccessfsblobstore/FsBlobRef.cpp
        filesystem/parallelaccessfsblobstore/FileBlobRef.cpp
        filesystem/parallelaccessfsblobstore/SymlinkBlobRef.cpp
        filesystem/CrySymlink.cpp
        filesystem/CryDir.cpp
        filesystem/cachingfsblobstore/DirBlobRef.cpp
        filesystem/cachingfsblobstore/CachingFsBlobStore.cpp
        filesystem/cachingfsblobstore/FsBlobRef.cpp
        filesystem/cachingfsblobstore/FileBlobRef.cpp
        filesystem/cachingfsblobstore/SymlinkBlobRef.cpp
        filesystem/CryFile.cpp
        filesystem/CryDevice.cpp
        localstate/LocalStateDir.cpp
        localstate/LocalStateMetadata.cpp
        localstate/BasedirMetadata.cpp
)

add_library(${PROJECT_NAME} STATIC ${LIB_SOURCES})
target_link_libraries(${PROJECT_NAME} PUBLIC cpp-utils fspp-interface blockstore blobstore gitversion)
target_add_boost(${PROJECT_NAME} program_options chrono) # TODO Check that dependent projects don't get boost added (use PRIVATE here)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

#install(TARGETS ${PROJECT_NAME}
#        DESTINATION lib
#        CONFIGURATIONS Release
#)

=== cryptopp/CMakeLists.txt ===
project(mycryptopp)

add_library(cryptopp dummy.cpp)
# note: include directory is called vendor_cryptopp instead of cryptopp to avoid include clashes with system headers
target_include_directories(cryptopp SYSTEM INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

# Forward debug build info (i.e. set CRYPTOPP_DEBUG variable if building in debug mode)
target_compile_definitions(cryptopp PUBLIC $<$<CONFIG:Debug>:CRYPTOPP_DEBUG>) # add to all targets depending on this
add_compile_options($<$<CONFIG:Debug>:-DCRYPTOPP_DEBUG>) # add to stuff built in subdirectories (like the actual library)

if(NOT DISABLE_OPENMP)
    find_package(OpenMP)

    if (OPENMP_FOUND OR OPENMP_CXX_FOUND)
        message(STATUS "Found libomp without any special flags")
    endif()

    # If OpenMP wasn't found, try if we can find it in the default Macports location
    if((NOT OPENMP_FOUND) AND (NOT OPENMP_CXX_FOUND) AND EXISTS "/opt/local/lib/libomp/libomp.dylib") # older cmake uses OPENMP_FOUND, newer cmake also sets OPENMP_CXX_FOUND, homebrew installations seem only to get the latter set.
        set(OpenMP_CXX_FLAGS "-Xpreprocessor -fopenmp -I/opt/local/include/libomp/")
        set(OpenMP_CXX_LIB_NAMES omp)
        set(OpenMP_omp_LIBRARY /opt/local/lib/libomp/libomp.dylib)

        find_package(OpenMP)
        if (OPENMP_FOUND OR OPENMP_CXX_FOUND)
            message(STATUS "Found libomp in macports default location.")
        else()
            message(FATAL_ERROR "Didn't find libomp. Tried macports default location but also didn't find it.")
        endif()
    endif()

    # If OpenMP wasn't found, try if we can find it in the default Homebrew location
    if((NOT OPENMP_FOUND) AND (NOT OPENMP_CXX_FOUND) AND EXISTS "/usr/local/opt/libomp/lib/libomp.dylib")
        set(OpenMP_CXX_FLAGS "-Xpreprocessor -fopenmp -I/usr/local/opt/libomp/include")
        set(OpenMP_CXX_LIB_NAMES omp)
        set(OpenMP_omp_LIBRARY /usr/local/opt/libomp/lib/libomp.dylib)

        find_package(OpenMP)
        if (OPENMP_FOUND OR OPENMP_CXX_FOUND)
            message(STATUS "Found libomp in homebrew default location.")
        else()
            message(FATAL_ERROR "Didn't find libomp. Tried homebrew default location but also didn't find it.")
        endif()
    endif()

    set(Additional_OpenMP_Libraries_Workaround "")

    # Workaround because older cmake on apple doesn't support FindOpenMP
    if((NOT OPENMP_FOUND) AND (NOT OPENMP_CXX_FOUND))
        if((APPLE AND ((CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang") OR (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")))
                AND ((CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "7.0") AND (CMAKE_VERSION VERSION_LESS "3.12.0")))
            message(STATUS "Applying workaround for OSX OpenMP with old cmake that doesn't have FindOpenMP")
            set(OpenMP_CXX_FLAGS "-Xclang -fopenmp")
            set(Additional_OpenMP_Libraries_Workaround "-lomp")
        else()
            message(FATAL_ERROR "Did not find OpenMP. Build with -DDISABLE_OPENMP=ON if you want to allow this and are willing to take the performance hit.")
        endif()
    endif()

    if(NOT TARGET OpenMP::OpenMP_CXX)
        # We're on cmake < 3.9, handle behavior of the old FindOpenMP implementation
        message(STATUS "Applying workaround for old CMake that doesn't define FindOpenMP using targets")
        add_library(OpenMP_TARGET INTERFACE)
        add_library(OpenMP::OpenMP_CXX ALIAS OpenMP_TARGET)
        target_compile_options(OpenMP_TARGET INTERFACE ${OpenMP_CXX_FLAGS}) # add to all targets depending on this
        find_package(Threads REQUIRED)
        target_link_libraries(OpenMP_TARGET INTERFACE Threads::Threads)
        target_link_libraries(OpenMP_TARGET INTERFACE ${OpenMP_CXX_FLAGS} ${Additional_OpenMP_Libraries_Workaround})
    endif()

    target_link_libraries(cryptopp PUBLIC ${OpenMP_CXX_FLAGS}) # Workaround for Ubuntu 18.04 that otherwise doesn't set -fopenmp for linking
    target_link_libraries(cryptopp PUBLIC OpenMP::OpenMP_CXX)

    # also add these flags to the third party Crypto++ build setup that is built in a subdirectory
    message(STATUS "OpenMP flags: ${OpenMP_CXX_FLAGS}")
    string(REPLACE " " ";" REPLACED_FLAGS ${OpenMP_CXX_FLAGS})
    add_compile_options(${REPLACED_FLAGS})
else()
    message(WARNING "OpenMP is disabled. This can cause degraded performance.")
endif()


set(BUILD_TESTING OFF CACHE BOOL "")
set(BUILD_DOCUMENTATION OFF CACHE BOOL "")
set(BUILD_SHARED OFF CACHE BOOL "")
set(BUILD_STATIC ON CACHE BOOL "")
set(cryptocpp_DISPLAY_CMAKE_SUPPORT_WARNING OFF CACHE BOOL "")
add_subdirectory(vendor_cryptopp EXCLUDE_FROM_ALL)

target_link_libraries(cryptopp PRIVATE cryptopp-static)

=== gitversion/CMakeLists.txt ===
project (gitversion-test)

set(SOURCES
    ParserTest.cpp
    VersionCompareTest.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} my-gtest-main googletest gitversion)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== my-gtest-main/CMakeLists.txt ===
project (my-gtest-main)

set(SOURCES
    my-gtest-main.cpp
)

add_library(${PROJECT_NAME} STATIC ${SOURCES})
target_link_libraries(${PROJECT_NAME} PUBLIC googletest cpp-utils)
target_add_boost(${PROJECT_NAME} filesystem system)
target_include_directories(${PROJECT_NAME} PUBLIC .)

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== stats/CMakeLists.txt ===
project (stats)

set(SOURCES
        main.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} PUBLIC cryfs cpp-utils gitversion)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})
set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME cryfs-stats)

=== cryptopp/vendor_cryptopp/CMakeLists.txt ===
# Please ensure your changes or patch meets minimum requirements.
#   The minimum requirements are 2.8.6. It roughly equates to
#   Ubuntu 14.05 LTS or Solaris 11.3. Please do not check in something
#   for 3.5.0 or higher because it will break LTS operating systems
#   and a number of developer boards used for testing. To test your
#   changes, please set up a Ubuntu 14.05 LTS system.

# Should we be setting things like this? We are not a C project
# so nothing should be done with the C compiler. But there is
# no reliable way to tell CMake we are C++.
# Cannot set this... Breaks Linux PowerPC with Clang:
# SET(CMAKE_C_COMPILER ${CMAKE_CXX_COMPILER})
# # error "The CMAKE_C_COMPILER is set to a C++ compiler"

if(NOT DEFINED cryptocpp_DISPLAY_CMAKE_SUPPORT_WARNING)
  set(cryptocpp_DISPLAY_CMAKE_SUPPORT_WARNING 1)
endif()
if(cryptocpp_DISPLAY_CMAKE_SUPPORT_WARNING)
  message( STATUS
"*************************************************************************\n"
"The Crypto++ library does not officially support CMake. CMake support is a\n"
"community effort, and the library works with the folks using CMake to help\n"
"improve it. If you find an issue then please fix it or report it at\n"
"https://github.com/noloader/cryptopp-cmake.\n"
"-- *************************************************************************"
)
endif()

# Print useful information
message( STATUS "CMake version ${CMAKE_VERSION}" )

cmake_minimum_required(VERSION 2.8.6)
if (${CMAKE_VERSION} VERSION_LESS "3.0.0")
  project(cryptopp)
  set(cryptopp_VERSION_MAJOR 8)
  set(cryptopp_VERSION_MINOR 2)
  set(cryptopp_VERSION_PATCH 0)
else ()
  cmake_policy(SET CMP0048 NEW)
  project(cryptopp VERSION 8.2.0)
  if (NOT ${CMAKE_VERSION} VERSION_LESS "3.1.0")
    cmake_policy(SET CMP0054 NEW)
  endif ()
endif ()

# Need to set SRC_DIR manually after removing the Python library code.
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})

# Make RelWithDebInfo the default (it does e.g. add '-O2 -g -DNDEBUG' for GNU)
#   If not in multi-configuration environments, no explicit build type or CXX
#   flags are set by the user and if we are the root CMakeLists.txt file.
if (NOT CMAKE_CONFIGURATION_TYPES AND
    NOT CMAKE_NO_BUILD_TYPE AND
    NOT CMAKE_BUILD_TYPE AND
    NOT CMAKE_CXX_FLAGS AND
    CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif ()

include(GNUInstallDirs)
include(CheckCXXCompilerFlag)

# We now carry around test programs. test_cxx.cxx is the default C++ one.
# Also see https://github.com/weidai11/cryptopp/issues/741.
set(TEST_PROG_DIR ${SRC_DIR}/TestPrograms)
set(TEST_CXX_FILE ${TEST_PROG_DIR}/test_cxx.cxx)

#============================================================================
# Settable options
#============================================================================

option(BUILD_STATIC "Build static library" ON)
option(BUILD_SHARED "Build shared library" ON)
option(BUILD_TESTING "Build library tests" ON)
option(BUILD_DOCUMENTATION "Use Doxygen to create the HTML based API documentation" OFF)
option(USE_INTERMEDIATE_OBJECTS_TARGET "Use a common intermediate objects target for the static and shared library targets" ON)

# These are IA-32 options. TODO: Add ARM A-32, Aarch64 and Power8 options.
option(DISABLE_ASM "Disable ASM" OFF)
option(DISABLE_SSSE3 "Disable SSSE3" OFF)
option(DISABLE_SSE4 "Disable SSE4" OFF)
option(DISABLE_AESNI "Disable AES-NI" OFF)
option(DISABLE_SHA "Disable SHA" OFF)
option(DISABLE_AVX "Disable AVX" OFF)
option(DISABLE_AVX2 "Disable AVX2" OFF)
option(CRYPTOPP_NATIVE_ARCH "Enable native architecture" OFF)
set(CRYPTOPP_DATA_DIR "" CACHE PATH "Crypto++ test data directory")

#============================================================================
# Compiler options
#============================================================================

set(CRYPTOPP_COMPILE_DEFINITIONS)
set(CRYPTOPP_COMPILE_OPTIONS)

# Stop hiding the damn output...
# set(CMAKE_VERBOSE_MAKEFILE on)

# Always 1 ahead in Master. Also see http://groups.google.com/forum/#!topic/cryptopp-users/SFhqLDTQPG4
set(LIB_VER ${cryptopp_VERSION_MAJOR}${cryptopp_VERSION_MINOR}${cryptopp_VERSION_PATCH})

# Don't use RPATH's. The resulting binary could fail a security audit.
set(CMAKE_MACOSX_RPATH 0)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
  list(APPEND CRYPTOPP_COMPILE_OPTIONS -wd68 -wd186 -wd279 -wd327 -wd161 -wd3180)
endif ()

# Also see http://github.com/weidai11/cryptopp/issues/395
if (DISABLE_ASM)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ASM)
endif ()
if (DISABLE_SSSE3)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_SSSE3)
endif ()
if (DISABLE_SSE4)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_SSSE4)
endif ()
if (DISABLE_AESNI)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_AESNI)
endif ()
if (DISABLE_SHA)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_SHA)
endif ()
if (DISABLE_ALTIVEC)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ALTIVEC)
endif ()
if (DISABLE_POWER7)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_POWER7)
endif ()
if (DISABLE_POWER8)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_POWER8)
endif ()
if (DISABLE_POWER9)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_POWER9)
endif ()
if (NOT CRYPTOPP_DATA_DIR STREQUAL "")
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS "CRYPTOPP_DATA_DIR=${CRYPTOPP_DATA_DIR}")
endif ()

###############################################################################

# Try to find a Posix compatible grep and sed. Solaris, Digital Unix,
#   Tru64, HP-UX and a few others need tweaking

if (EXISTS /usr/xpg4/bin/grep)
  set(GREP_CMD /usr/xpg4/bin/grep)
elseif (EXISTS /usr/gnu/bin/grep)
  set(GREP_CMD /usr/gnu/bin/grep)
elseif (EXISTS /usr/linux/bin/grep)
  set(GREP_CMD /usr/linux/bin/grep)
else ()
  set(GREP_CMD grep)
endif ()

if (EXISTS /usr/xpg4/bin/sed)
  set(SED_CMD /usr/xpg4/bin/sed)
elseif (EXISTS /usr/gnu/bin/sed)
  set(SED_CMD /usr/gnu/bin/sed)
elseif (EXISTS /usr/linux/bin/sed)
  set(SED_CMD /usr/linux/bin/sed)
else ()
  set(SED_CMD sed)
endif ()

###############################################################################

function(CheckCompileOption opt var)

  if (MSVC)

    # TODO: improve this...
    CHECK_CXX_COMPILER_FLAG(${opt} ${var})

  elseif (CMAKE_CXX_COMPILER_ID MATCHES "SunPro")

    message(STATUS "Performing Test ${var}")
    execute_process(
      COMMAND sh -c "${CMAKE_CXX_COMPILER} ${CMAKE_CXX_FLAGS} ${opt} -c ${TEST_CXX_FILE} 2>&1"
      COMMAND ${GREP_CMD} -i -c -E "illegal value ignored"
      RESULT_VARIABLE COMMAND_RESULT
      OUTPUT_VARIABLE COMMAND_OUTPUT
      OUTPUT_STRIP_TRAILING_WHITESPACE)

    # No dereference below. Thanks for the warning, CMake (not!).
    if (COMMAND_RESULT AND NOT COMMAND_OUTPUT)
      set(${var} 1 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Success")
    else ()
      set(${var} 0 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Failed")
    endif ()

  # Must use CMAKE_CXX_COMPILER here due to XLC 13.1 and LLVM front-end.
  elseif (CMAKE_CXX_COMPILER MATCHES "xlC")

    message(STATUS "Performing Test ${var}")
    execute_process(
      COMMAND sh -c "${CMAKE_CXX_COMPILER} ${CMAKE_CXX_FLAGS} ${opt} -c ${TEST_CXX_FILE} 2>&1"
      COMMAND ${GREP_CMD} -i -c -E "Unrecognized value"
      RESULT_VARIABLE COMMAND_RESULT
      OUTPUT_VARIABLE COMMAND_OUTPUT
      OUTPUT_STRIP_TRAILING_WHITESPACE)

    # No dereference below. Thanks for the warning, CMake (not!).
    if (COMMAND_RESULT AND NOT COMMAND_OUTPUT)
      set(${var} 1 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Success")
    else ()
      set(${var} 0 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Failed")
    endif ()

  else ()

    CHECK_CXX_COMPILER_FLAG(${opt} ${var})

  endif ()

endfunction(CheckCompileOption)

function(CheckCompileLinkOption opt var prog)

  if (MSVC)

    # TODO: improve this...
    CHECK_CXX_COMPILER_FLAG(${opt} ${var})

  else ()

    message(STATUS "Performing Test ${var}")
    execute_process(
      COMMAND sh -c "${CMAKE_CXX_COMPILER} ${CMAKE_CXX_FLAGS} ${opt} ${prog} 2>&1"
      RESULT_VARIABLE COMMAND_RESULT
      OUTPUT_VARIABLE COMMAND_OUTPUT
      OUTPUT_STRIP_TRAILING_WHITESPACE)

    # message(STATUS "RESULT_VARIABLE ${RESULT_VARIABLE}")
    # message(STATUS "COMMAND_RESULT ${COMMAND_RESULT}")
    # message(STATUS "OUTPUT_VARIABLE ${OUTPUT_VARIABLE}")
    # message(STATUS "COMMAND_OUTPUT ${COMMAND_OUTPUT}")

    # This test is strict. We require two things. First, the invocation
    # of the compile command must return 0. Second, there must be no
    # messages on the console. We are interested in diagnostics like
    # warnings to decide when to reject an option. But we will probably
    # capture chatty compiler that want to say, "Hooray, success". For
    # chatty compilers we will need to find a quiet option and use it
    # for the test. Microsoft compilers come to mind.
    if ("${COMMAND_RESULT}" EQUAL 0 AND "${COMMAND_OUTPUT}" STREQUAL "")
      set(${var} 1 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Success")
    else ()
      set(${var} 0 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Failed")
    endif ()

  endif ()

endfunction(CheckCompileLinkOption)

function(AddCompileOption opt)

    if ("${COMMAND_OUTPUT}" NOT STREQUAL "")
      list(APPEND CRYPTOPP_COMPILE_OPTIONS "${opt}")
    endif ()

endfunction(AddCompileOption)

###############################################################################

function(DumpMachine output pattern)

  if (MSVC)

    # CMake does not provide a generic shell/terminal mechanism
    #  and Microsoft environments don't know what 'sh' is.
    set(${output} 0 PARENT_SCOPE)

  else ()

    execute_process(
      COMMAND sh -c "${CMAKE_CXX_COMPILER} -dumpmachine 2>&1"
      COMMAND ${GREP_CMD} -i -c -E "${pattern}"
      OUTPUT_VARIABLE ${output}
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    set(${output} "${${output}}" PARENT_SCOPE)

  endif()

endfunction(DumpMachine)

# Thansk to Anonimal for MinGW; see http://github.com/weidai11/cryptopp/issues/466
DumpMachine(CRYPTOPP_AMD64 "amd64|x86_64")
DumpMachine(CRYPTOPP_I386 "i.86")
DumpMachine(CRYPTOPP_MINGW32 "\\<mingw32\\>")
DumpMachine(CRYPTOPP_MINGW64 "w64-mingw32|mingw64")
DumpMachine(CRYPTOPP_X32 "x32")
DumpMachine(CRYPTOPP_AARCH32 "Aarch32")
DumpMachine(CRYPTOPP_AARCH64 "Aarch64")
DumpMachine(CRYPTOPP_ARMHF "armhf|arm7l|eabihf")
DumpMachine(CRYPTOPP_ARM "\\<arm\\>")

# Detecting PowerPC is only good with GCC. IBM XLC compiler is
# a little different and I don't know how to ask to the triplet
# XLC is targeting. Below we punt by setting CRYPTOPP_POWERPC64
# if we detect the compiler is XLC.
DumpMachine(CRYPTOPP_POWERPC "ppc|powerpc")
DumpMachine(CRYPTOPP_POWERPC64 "ppc64")

###############################################################################

# Test SunCC for a string like 'CC: Sun C++ 5.13 SunOS_i386'
if (NOT CRYPTOPP_SOLARIS)
  execute_process(COMMAND sh -c "${CMAKE_CXX_COMPILER} -V 2>&1"
    COMMAND ${GREP_CMD} -i -c "SunOS"
    OUTPUT_VARIABLE CRYPTOPP_SOLARIS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif ()

# Test GCC for a string like 'i386-pc-solaris2.11'
if (NOT CRYPTOPP_SOLARIS)
  execute_process(COMMAND sh -c "${CMAKE_CXX_COMPILER} -dumpmachine 2>&1"
    COMMAND ${GREP_CMD} -i -c "Solaris"
    OUTPUT_VARIABLE CRYPTOPP_SOLARIS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif ()

# Fixup PowerPC. If both 32-bit and 64-bit use 64-bit.
if (CRYPTOPP_POWERPC AND CRYPTOPP_POWERPC64)
  unset(CRYPTOPP_POWERPC)
endif ()

# Fixup for xlC compiler. -dumpmachine fails so we miss PowerPC
# TODO: something better than proxying the platform via compiler
# Must use CMAKE_CXX_COMPILER here due to XLC 13.1 and LLVM front-end.
if (CMAKE_CXX_COMPILER MATCHES "xlC")
  message ("-- Fixing platform due to IBM xlC")
  set(CRYPTOPP_POWERPC64 1)
endif ()

=== fspp/fs_interface/CMakeLists.txt ===
project (fspp-interface)

set(SOURCES
  Device.cpp
  Dir.cpp
  File.cpp
  Node.cpp
  OpenFile.cpp
  Symlink.cpp
  Types.cpp)

add_library(${PROJECT_NAME} STATIC ${SOURCES})

target_link_libraries(${PROJECT_NAME} PUBLIC cpp-utils)

target_add_boost(${PROJECT_NAME} filesystem system)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== fspp/fuse/CMakeLists.txt ===
project (fspp-fuse)

set(SOURCES
  ../impl/FilesystemImpl.cpp
  ../impl/Profiler.cpp
  ../fuse/Fuse.cpp
)

add_library(${PROJECT_NAME} STATIC ${SOURCES})

target_compile_definitions(${PROJECT_NAME} PUBLIC _FILE_OFFSET_BITS=64)
target_link_libraries(${PROJECT_NAME} PUBLIC cpp-utils fspp-interface)

target_add_boost(${PROJECT_NAME} filesystem system thread chrono)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  get_target_architecture(TARGET_ARCH)
  message(STATUS "Linking to Dokan ${TARGET_ARCH}")
  if ("${TARGET_ARCH}" STREQUAL "x86_64")
	set(DOKAN_LIB_PATH "${DOKAN_PATH}")
  elseif("${TARGET_ARCH}" STREQUAL "i386")
    set(DOKAN_LIB_PATH "${DOKAN_PATH}/x86")
  else()
    message(FATAL_ERROR "Unsupported architecture: ${TARGET_ARCH}")
  endif()

  target_include_directories(${PROJECT_NAME} PUBLIC "${DOKAN_PATH}/include")
  target_link_libraries(${PROJECT_NAME} PUBLIC "${DOKAN_LIB_PATH}/lib/dokan1.lib")
  #target_link_libraries(${PROJECT_NAME} PUBLIC "${DOKAN_LIB_PATH}/lib/dokannp1.lib")
  target_link_libraries(${PROJECT_NAME} PUBLIC "${DOKAN_LIB_PATH}/lib/dokanfuse1.lib")

  install(FILES "${DOKAN_LIB_PATH}/dokan1.dll" "${DOKAN_LIB_PATH}/dokanfuse1.dll"
    DESTINATION "${CMAKE_INSTALL_BINDIR}"
  )

elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(CMAKE_FIND_FRAMEWORK LAST)
  find_library_with_path(FUSE "osxfuse" FUSE_LIB_PATH)
  target_link_libraries(${PROJECT_NAME} PUBLIC ${FUSE})
else() # Linux
  find_library_with_path(FUSE "fuse" FUSE_LIB_PATH)
  target_link_libraries(${PROJECT_NAME} PUBLIC ${FUSE})
endif()

=== debian/changelog ===
cryfs (0.10.2-5) unstable; urgency=medium

  * Add an autopkgtest for terminating options.

 -- David Steele <steele@debian.org>  Thu, 31 Dec 2020 10:02:29 -0500

cryfs (0.10.2-4) unstable; urgency=medium

  * Update autopkgtests to a more streamlined test.

 -- David Steele <steele@debian.org>  Sun, 27 Dec 2020 20:02:25 -0500

cryfs (0.10.2-3) unstable; urgency=medium

  * Remove python 2 build dependency (Closes: #942924).

 -- David Steele <steele@debian.org>  Sat, 02 Nov 2019 22:46:34 -0400

cryfs (0.10.2-2) unstable; urgency=medium

  * Fix build failure in man install.

 -- David Steele <steele@debian.org>  Wed, 30 Oct 2019 22:15:20 -0400

cryfs (0.10.2-1) unstable; urgency=medium

  * New upstream version.
    - Fixes file corruption with concurrent access.

 -- David Steele <steele@debian.org>  Sat, 14 Sep 2019 23:24:25 -0400

=== debian/control ===
Source: cryfs
Maintainer: David Steele <steele@debian.org>
Section: utils
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               libcurl4-openssl-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-chrono-dev,
               libboost-program-options-dev,
               libboost-thread-dev,
               libcrypto++-dev (>= 5.6.4),
               libssl-dev,
               libfuse-dev,
               python3-all,
Standards-Version: 4.1.2
Vcs-Browser: https://github.com/davesteele/cryfs
Vcs-Git: https://github.com/davesteele/cryfs.git -b debian
Homepage: https://www.cryfs.org/

Package: cryfs
Architecture: linux-any
Depends: fuse,
         ${misc:Depends},
         ${shlibs:Depends}
Description: encrypt your files and store them in the cloud
 CryFS encrypts your files, so you can safely store them anywhere. It works
 well together with cloud services like Dropbox, iCloud, OneDrive and others.

=== debian/rules ===
#!/usr/bin/make -f

ARCH := $(shell uname -m)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DBoost_USE_STATIC_LIBs=off \
                         -DCRYFS_UPDATE_CHECKS=off -DBUILD_TESTING=False; \

override_dh_auto_build:
	dh_auto_build
	cp obj*/src/cryfs-cli/cryfs .

=== debian/tests/control ===

# Test cryfs creation and mounting
# This does not work in lxc - fuse and containers do not get along
Tests: mounttest.py
Depends: @, python3-pexpect, haveged
Restrictions: isolation-machine

# Britney debci does not currently (12/20) support the isolation-machine
# restriction, leading to a 'neutral' result if mounttest is the only test.
# Unfortunatly, there is a bug in britney such that, if there is an
# infrastructure-based failure for a particular version/architecture, that
# result is preferred over a subsequent 'neutral', which can lead to a
# permanent transition block.
Tests: optiontest
Depends: @

## cryfs 0.11.0

=== cryfs-unmount/CMakeLists.txt ===
project (cryfs-unmount)
INCLUDE(GNUInstallDirs)

set(SOURCES
	program_options/ProgramOptions.cpp
	program_options/Parser.cpp
	Cli.cpp
)

add_library(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} PUBLIC cpp-utils cryfs fspp-fuse)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})
target_add_boost(${PROJECT_NAME})

add_executable(${PROJECT_NAME}_bin main_unmount.cpp)
set_target_properties(${PROJECT_NAME}_bin PROPERTIES OUTPUT_NAME cryfs-unmount)
target_link_libraries(${PROJECT_NAME}_bin PUBLIC ${PROJECT_NAME})
target_enable_style_warnings(${PROJECT_NAME}_bin)
target_activate_cpp14(${PROJECT_NAME}_bin)

install(TARGETS ${PROJECT_NAME}_bin
        DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== cryptopp/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
 project(mycryptopp)
 
-add_library(cryptopp dummy.cpp)
+add_library(cryptopp INTERFACE)
 # note: include directory is called vendor_cryptopp instead of cryptopp to avoid include clashes with system headers
 target_include_directories(cryptopp SYSTEM INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})
 
 # Forward debug build info (i.e. set CRYPTOPP_DEBUG variable if building in debug mode)
-target_compile_definitions(cryptopp PUBLIC $<$<CONFIG:Debug>:CRYPTOPP_DEBUG>) # add to all targets depending on this
+target_compile_definitions(cryptopp INTERFACE $<$<CONFIG:Debug>:CRYPTOPP_DEBUG>) # add to all targets depending on this
 add_compile_options($<$<CONFIG:Debug>:-DCRYPTOPP_DEBUG>) # add to stuff built in subdirectories (like the actual library)
 
 if(NOT DISABLE_OPENMP)
@@ -68,8 +68,8 @@
         target_link_libraries(OpenMP_TARGET INTERFACE ${OpenMP_CXX_FLAGS} ${Additional_OpenMP_Libraries_Workaround})
     endif()
 
-    target_link_libraries(cryptopp PUBLIC ${OpenMP_CXX_FLAGS}) # Workaround for Ubuntu 18.04 that otherwise doesn't set -fopenmp for linking
-    target_link_libraries(cryptopp PUBLIC OpenMP::OpenMP_CXX)
+    target_link_libraries(cryptopp INTERFACE ${OpenMP_CXX_FLAGS}) # Workaround for Ubuntu 18.04 that otherwise doesn't set -fopenmp for linking
+    target_link_libraries(cryptopp INTERFACE OpenMP::OpenMP_CXX)
 
     # also add these flags to the third party Crypto++ build setup that is built in a subdirectory
     message(STATUS "OpenMP flags: ${OpenMP_CXX_FLAGS}")
@@ -80,11 +80,11 @@
 endif()
 
 
-set(BUILD_TESTING OFF CACHE BOOL "")
+set(CRYPTOPP_BUILD_TESTING OFF CACHE BOOL "")
 set(BUILD_DOCUMENTATION OFF CACHE BOOL "")
 set(BUILD_SHARED OFF CACHE BOOL "")
 set(BUILD_STATIC ON CACHE BOOL "")
 set(cryptocpp_DISPLAY_CMAKE_SUPPORT_WARNING OFF CACHE BOOL "")
 add_subdirectory(vendor_cryptopp EXCLUDE_FROM_ALL)
 
-target_link_libraries(cryptopp PRIVATE cryptopp-static)
+target_link_libraries(cryptopp INTERFACE cryptopp-static)

=== cryptopp/vendor_cryptopp/CMakeLists.txt ===
--- 
+++ 
@@ -30,14 +30,15 @@
 message( STATUS "CMake version ${CMAKE_VERSION}" )
 
 cmake_minimum_required(VERSION 2.8.6)
+cmake_policy(SET CMP0069 NEW)
 if (${CMAKE_VERSION} VERSION_LESS "3.0.0")
   project(cryptopp)
   set(cryptopp_VERSION_MAJOR 8)
-  set(cryptopp_VERSION_MINOR 2)
+  set(cryptopp_VERSION_MINOR 5)
   set(cryptopp_VERSION_PATCH 0)
 else ()
   cmake_policy(SET CMP0048 NEW)
-  project(cryptopp VERSION 8.2.0)
+  project(cryptopp VERSION 8.3.0)
   if (NOT ${CMAKE_VERSION} VERSION_LESS "3.1.0")
     cmake_policy(SET CMP0054 NEW)
   endif ()
@@ -71,7 +72,7 @@
 
 option(BUILD_STATIC "Build static library" ON)
 option(BUILD_SHARED "Build shared library" ON)
-option(BUILD_TESTING "Build library tests" ON)
+option(CRYPTOPP_BUILD_TESTING "Build library tests" ON)
 option(BUILD_DOCUMENTATION "Use Doxygen to create the HTML based API documentation" OFF)
 option(USE_INTERMEDIATE_OBJECTS_TARGET "Use a common intermediate objects target for the static and shared library targets" ON)
 
@@ -83,7 +84,6 @@
 option(DISABLE_SHA "Disable SHA" OFF)
 option(DISABLE_AVX "Disable AVX" OFF)
 option(DISABLE_AVX2 "Disable AVX2" OFF)
-option(CRYPTOPP_NATIVE_ARCH "Enable native architecture" OFF)
 set(CRYPTOPP_DATA_DIR "" CACHE PATH "Crypto++ test data directory")
 
 #============================================================================
@@ -116,8 +116,23 @@
 if (DISABLE_SSE4)
   list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_SSSE4)
 endif ()
+if (DISABLE_CLMUL)
+  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_CLMUL)
+endif ()
 if (DISABLE_AESNI)
   list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_AESNI)
+endif ()
+if (DISABLE_RDRAND)
+  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_RDRAND)
+endif ()
+if (DISABLE_RDSEED)
+  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_RDSEED)
+endif ()
+if (DISABLE_AVX)
+  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_AVX)
+endif ()
+if (DISABLE_AVX2)
+  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_AVX2)
 endif ()
 if (DISABLE_SHA)
   list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_SHA)
@@ -226,28 +241,11 @@
     # TODO: improve this...
     CHECK_CXX_COMPILER_FLAG(${opt} ${var})
 
-  else ()
+  elseif (APPLE)
 
     message(STATUS "Performing Test ${var}")
-    execute_process(
-      COMMAND sh -c "${CMAKE_CXX_COMPILER} ${CMAKE_CXX_FLAGS} ${opt} ${prog} 2>&1"
-      RESULT_VARIABLE COMMAND_RESULT
-      OUTPUT_VARIABLE COMMAND_OUTPUT
-      OUTPUT_STRIP_TRAILING_WHITESPACE)
-
-    # message(STATUS "RESULT_VARIABLE ${RESULT_VARIABLE}")
-    # message(STATUS "COMMAND_RESULT ${COMMAND_RESULT}")
-    # message(STATUS "OUTPUT_VARIABLE ${OUTPUT_VARIABLE}")
-    # message(STATUS "COMMAND_OUTPUT ${COMMAND_OUTPUT}")
-
-    # This test is strict. We require two things. First, the invocation
-    # of the compile command must return 0. Second, there must be no
-    # messages on the console. We are interested in diagnostics like
-    # warnings to decide when to reject an option. But we will probably
-    # capture chatty compiler that want to say, "Hooray, success". For
-    # chatty compilers we will need to find a quiet option and use it
-    # for the test. Microsoft compilers come to mind.
-    if ("${COMMAND_RESULT}" EQUAL 0 AND "${COMMAND_OUTPUT}" STREQUAL "")
+    try_compile(COMMAND_SUCCESS ${CMAKE_BINARY_DIR} ${prog} COMPILE_DEFINITIONS ${opt})
+    if (COMMAND_SUCCESS)
       set(${var} 1 PARENT_SCOPE)
       message(STATUS "Performing Test ${var} - Success")
     else ()
@@ -255,6 +253,18 @@
       message(STATUS "Performing Test ${var} - Failed")
     endif ()
 
+  else ()
+
+    message(STATUS "Performing Test ${var}")
+    try_compile(COMMAND_SUCCESS ${CMAKE_BINARY_DIR} ${prog} COMPILE_DEFINITIONS ${opt})
+    if (COMMAND_SUCCESS)
+        set(${var} 1 PARENT_SCOPE)
+        message(STATUS "Performing Test ${var} - Success")
+    else ()
+      set(${var} 0 PARENT_SCOPE)
+      message(STATUS "Performing Test ${var} - Failed")
+    endif ()
+
   endif ()
 
 endfunction(CheckCompileLinkOption)
@@ -278,35 +288,36 @@
     set(${output} 0 PARENT_SCOPE)
 
   else ()
-
-    execute_process(
-      COMMAND sh -c "${CMAKE_CXX_COMPILER} -dumpmachine 2>&1"
-      COMMAND ${GREP_CMD} -i -c -E "${pattern}"
-      OUTPUT_VARIABLE ${output}
-      OUTPUT_STRIP_TRAILING_WHITESPACE)
-    set(${output} "${${output}}" PARENT_SCOPE)
-
+      if(CMAKE_SYSTEM_PROCESSOR MATCHES ${pattern})
+          set(${output} TRUE PARENT_SCOPE)
+      endif()
   endif()
 
 endfunction(DumpMachine)
 
 # Thansk to Anonimal for MinGW; see http://github.com/weidai11/cryptopp/issues/466
-DumpMachine(CRYPTOPP_AMD64 "amd64|x86_64")
-DumpMachine(CRYPTOPP_I386 "i.86")
-DumpMachine(CRYPTOPP_MINGW32 "\\<mingw32\\>")
-DumpMachine(CRYPTOPP_MINGW64 "w64-mingw32|mingw64")
-DumpMachine(CRYPTOPP_X32 "x32")
-DumpMachine(CRYPTOPP_AARCH32 "Aarch32")
-DumpMachine(CRYPTOPP_AARCH64 "Aarch64")
-DumpMachine(CRYPTOPP_ARMHF "armhf|arm7l|eabihf")
-DumpMachine(CRYPTOPP_ARM "\\<arm\\>")
-
-# Detecting PowerPC is only good with GCC. IBM XLC compiler is
-# a little different and I don't know how to ask to the triplet
-# XLC is targeting. Below we punt by setting CRYPTOPP_POWERPC64
-# if we detect the compiler is XLC.
-DumpMachine(CRYPTOPP_POWERPC "ppc|powerpc")
-DumpMachine(CRYPTOPP_POWERPC64 "ppc64")
+DumpMachine(CRYPTOPP_AMD64 "(x86_64|AMD64|amd64)")
+DumpMachine(CRYPTOPP_I386 "^i.86$")
+DumpMachine(CRYPTOPP_MINGW32 "^mingw32")
+DumpMachine(CRYPTOPP_MINGW64 "(w64-mingw32)|(mingw64)")
+DumpMachine(CRYPTOPP_ARMV8 "(armv8|aarch32|aarch64)")
+DumpMachine(CRYPTOPP_ARM32 "(arm|armhf|arm7l|eabihf)")
+DumpMachine(CRYPTOPP_PPC32 "^(powerpc|ppc)")
+DumpMachine(CRYPTOPP_PPC64 "^ppc64")
+
+# Cleanup 32/64 bit
+if (CRYPTOPP_AMD64)
+  set (CRYPTOPP_I386 0)
+endif ()
+
+if (CRYPTOPP_ARMV8)
+  set (CRYPTOPP_ARM32 0)
+endif ()
+
+if (CRYPTOPP_PPC64)
+  set (CRYPTOPP_PPC32 0)
+endif ()
+
 
 ###############################################################################
 
@@ -327,8 +338,8 @@
 endif ()
 
 # Fixup PowerPC. If both 32-bit and 64-bit use 64-bit.
-if (CRYPTOPP_POWERPC AND CRYPTOPP_POWERPC64)
-  unset(CRYPTOPP_POWERPC)
+if (CRYPTOPP_PPC32 AND CRYPTOPP_PPC64)
+  unset(CRYPTOPP_PPC32)
 endif ()
 
 # Fixup for xlC compiler. -dumpmachine fails so we miss PowerPC
@@ -336,6 +347,15 @@
 # Must use CMAKE_CXX_COMPILER here due to XLC 13.1 and LLVM front-end.
 if (CMAKE_CXX_COMPILER MATCHES "xlC")
   message ("-- Fixing platform due to IBM xlC")
-  set(CRYPTOPP_POWERPC64 1)
-endif ()
-
+  set(CRYPTOPP_PPC64 1)
+endif ()
+
+# DumpMachine SunCC style
+if (CMAKE_CXX_COMPILER_ID STREQUAL "SunPro")
+
+  # SunCC is 32-bit, but it builds both 32 and 64 bit. Use
+  execute_process(COMMAND sh -c "${CMAKE_CXX_COMPILER} -V 2>&1"
+    COMMAND ${GREP_CMD} -i -c "Sparc"
+    OUTPUT_VARIABLE CRYPTOPP_SPARC
+    OUTPUT_STRIP_TRAILING_WHITESPACE)
+

=== debian/changelog ===
cryfs (0.11.0-2) unstable; urgency=medium

  * Fix architecture builds.

 -- David Steele <steele@debian.org>  Mon, 03 Jan 2022 16:22:16 -0500

cryfs (0.11.0-1) unstable; urgency=medium

  * New upstream version.
  * New build system (Closes: #995135)
  * Add Unit Tests to package, and exercise in autopkgtest.

 -- David Steele <steele@debian.org>  Sun, 02 Jan 2022 11:19:57 -0500

## cryfs 0.11.1

=== cryptopp/CMakeLists.txt ===
project(mycryptopp)

add_library(cryptopp INTERFACE)
# note: include directory is called vendor_cryptopp instead of cryptopp to avoid include clashes with system headers
target_include_directories(cryptopp SYSTEM INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

# Forward debug build info (i.e. set CRYPTOPP_DEBUG variable if building in debug mode)
target_compile_definitions(cryptopp INTERFACE $<$<CONFIG:Debug>:CRYPTOPP_DEBUG>) # add to all targets depending on this
add_compile_options($<$<CONFIG:Debug>:-DCRYPTOPP_DEBUG>) # add to stuff built in subdirectories (like the actual library)

if (NOT DISABLE_OPENMP)
    set(USE_OPENMP ON CACHE BOOL "")
endif()
set(CRYPTOPP_BUILD_TESTING OFF CACHE BOOL "")
set(BUILD_DOCUMENTATION OFF CACHE BOOL "")
set(BUILD_SHARED OFF CACHE BOOL "")
set(BUILD_STATIC ON CACHE BOOL "")
set(cryptocpp_DISPLAY_CMAKE_SUPPORT_WARNING OFF CACHE BOOL "")
add_subdirectory(vendor_cryptopp EXCLUDE_FROM_ALL)

target_link_libraries(cryptopp INTERFACE cryptopp-static)

=== debian/changelog ===
cryfs (0.11.1-1) unstable; urgency=medium

  * New upstream version.

 -- David Steele <steele@debian.org>  Tue, 04 Jan 2022 11:44:50 -0500

=== debian/rules ===
#!/usr/bin/make -f

ARCH := $(shell uname -m)

%:
	dh $@

override_dh_auto_configure:
	mkdir -p build
	CXXF=
	if dpkg-architecture -e armel; then \
	    CXXF="-DCMAKE_CXX_FLAGS=$(CMAKE_CXX_FLAGS) -mfloat-abi=softfp"; \
	fi
	(cd build && cmake .. ${CXXF} -DDEPENDENCY_CONFIG=../cmake-utils/DependenciesFromLocalSystem.cmake -DBUILD_TESTING=ON -DCRYFS_UPDATE_CHECKS=OFF)

override_dh_auto_build:
	(cd build && make)
	./build/test/blobstore/blobstore-test
	./build/test/blockstore/blockstore-test
	# Config Compatibility tests fail on s390x, mipsel, and hppa archs
	./build/test/cryfs/cryfs-test --gtest_filter=-CryConfigCompatibilityTest.*
	./build/test/parallelaccessstore/parallelaccessstore-test
	./build/test/gitversion/gitversion-test
	# Test fails with pbuilder
	./build/test/cpp-utils/cpp-utils-test --gtest_filter=-HomedirTest.HomedirExists
	# ./build/test/cryfs-cli/cryfs-cli-test
	# Test requires root (and fuse)
	# ./build/test/fspp/fspp-test

=== debian/tests/control ===
--- 
+++ 
@@ -13,3 +13,31 @@
 # permanent transition block.
 Tests: optiontest
 Depends: @
+
+Test-Command: debian/tests/unittest blobstore
+Features: test-name=blobstore
+Depends: @
+
+Test-Command: debian/tests/unittest blockstore
+Features: test-name=blockstore
+Depends: @
+
+Test-Command: debian/tests/unittest cpp-utils
+Features: test-name=cpp-utils
+Depends: @
+
+Test-Command: debian/tests/unittest cryfs
+Features: test-name=cryfs
+Depends: @
+
+Test-Command: debian/tests/unittest cryfs-cli
+Features: test-name=cryfs-cli
+Depends: @
+
+Test-Command: debian/tests/unittest gitversion
+Features: test-name=gitversion
+Depends: @
+
+Test-Command: debian/tests/unittest parallelaccessstore
+Features: test-name=parallelaccessstore
+Depends: @

## cryfs 0.11.2

=== debian/changelog ===
cryfs (0.11.2-5build1) kinetic; urgency=medium

  * No-change rebuild against libfmt9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 21 Aug 2022 06:04:01 +0000

cryfs (0.11.2-5) unstable; urgency=medium

  * Potenial fix for libfmt 9.0 incompatibility (Closes: #1014684).

 -- David Steele <steele@debian.org>  Wed, 27 Jul 2022 21:25:32 -0400

cryfs (0.11.2-4) unstable; urgency=medium

  * DISABLE_ASM for armhf as well

 -- David Steele <steele@debian.org>  Mon, 28 Mar 2022 16:22:31 -0400

cryfs (0.11.2-3) unstable; urgency=medium

  * Address some armhf test failures.

 -- David Steele <steele@debian.org>  Sat, 12 Mar 2022 11:06:54 -0500

cryfs (0.11.2-2) unstable; urgency=medium

  * Harden build testing.
  * armel and armhg are building (Closes: #1006820).
  * Build tests passing on all archs (Closes: #1003679).

 -- David Steele <steele@debian.org>  Fri, 11 Mar 2022 13:20:41 -0500

cryfs (0.11.2-1) unstable; urgency=medium

  * Release 0.11.2-1
  * More changes to support armel build.

 -- David Steele <steele@debian.org>  Tue, 08 Mar 2022 12:31:15 -0500

cryfs (0.11.1-4) unstable; urgency=medium

  * Add upstream patch for cryptopp build vars.

 -- David Steele <steele@debian.org>  Mon, 07 Mar 2022 14:36:33 -0500

cryfs (0.11.1-3) unstable; urgency=medium

  * Escape the make var differently.

 -- David Steele <steele@debian.org>  Tue, 08 Feb 2022 20:37:04 -0500

cryfs (0.11.1-2) unstable; urgency=medium

  * Disable NEON on armel builds

 -- David Steele <steele@debian.org>  Tue, 08 Feb 2022 17:45:58 -0500

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,14 @@
 Source: cryfs
-Maintainer: David Steele <steele@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: David Steele <steele@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 13),
                cmake,
+               dpkg-dev,
+               pkg-config,
+               librange-v3-dev,
+               libspdlog-dev,
                libcurl4-openssl-dev,
                libboost-filesystem-dev,
                libboost-system-dev,
@@ -14,7 +19,8 @@
                libssl-dev,
                libfuse-dev,
                python3-all,
-Standards-Version: 4.1.2
+Rules-Requires-Root: no
+Standards-Version: 4.6.0.1
 Vcs-Browser: https://github.com/davesteele/cryfs
 Vcs-Git: https://github.com/davesteele/cryfs.git -b debian
 Homepage: https://www.cryfs.org/

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	mkdir -p build
	dpkg-architecture
	if `dpkg-architecture -e armel` || `dpkg-architecture -e armhf`; then \
	    echo "Performing armel build"; \
	    (cd build && cmake .. -DDISABLE_ASM=ON -DDEPENDENCY_CONFIG=../cmake-utils/DependenciesFromLocalSystem.cmake -DBUILD_TESTING=ON -DCRYFS_UPDATE_CHECKS=OFF); \
	else \
	    (cd build && cmake .. -DDEPENDENCY_CONFIG=../cmake-utils/DependenciesFromLocalSystem.cmake -DBUILD_TESTING=ON -DCRYFS_UPDATE_CHECKS=OFF); \
	fi

override_dh_auto_build:
	(cd build && make VERBOSE=1)
	./build/test/blobstore/blobstore-test 2>&1
	./build/test/blockstore/blockstore-test --gtest_filter='-CacheTest_RaceCondition.*' 2>&1
	# Config Compatibility tests fail on s390x, mipsel, and hppa archs
	./build/test/cryfs/cryfs-test --gtest_filter='-CryConfigCompatibilityTest.*' 2>&1
	./build/test/parallelaccessstore/parallelaccessstore-test 2>&1
	./build/test/gitversion/gitversion-test 2>&1
	# Test fails with pbuilder, and mipsel
	# ./build/test/cpp-utils/cpp-utils-test --gtest_filter='-HomedirTest.*' 2>&1
	# ./build/test/cryfs-cli/cryfs-cli-test
	# Test requires root (and fuse)
	# ./build/test/fspp/fspp-test
